#!/usr/bin/tclsh
#
# Script: QIParser.tcl
# Requires: QIPGlobals.resource
#
#	 Copyright q.i. productions 2001
#
# This miniapp is distributed under a pretty flexible licence, namely:
# you must adopt my belief system, which more likely than not involves
# a greater, single (or more) 'Supreme Wombat' that oversees all Life and
# happenings with the aforementioned Life.
# Just kidding. If you should happen to redistribute this script in part
# or whole, we'd appreciate it if you kept this notice and acknowledged 
# our part in the whole grand scheme of things, even if it just be around
# to your colleagues.
# We're not legally responsible for any changes you may make to the code that
# make it either a menace to society or injure some other party in any fashion,
# really. 
# Now, you're not legally bound to any of this, really, you're just going
# to lose major karma points if you do anything stupid (in the nasty sense).
#
# This script should be a relatively simple parser of the relatively
# simple Sane Magazine horoscopes file format, as defined at 
# http://www.sanemagazine.com/publish/formats/horos-0.5.dtd
#
# Please see the README.rtf file for more information on this script
# and how to use it.
#
# A full version of the licence notice is available online at
#     http://supertart.com/software/licence.html
# Write us and we'll send you stickers.
#
# Begin. _m 01.01.01

source QIPGlobals.tcl
source QIPUtils.tcl

#####################################
## init below
#####################################
## Set Flags....
#####################################
if {$argc == 0} {
	set content [loadSource "/~sanemag/publish/content/1.0/horoscopes.xml" "localhost"]
	source QIPHorosParse.tcl
	horosParse $content
	toFile [toHTML] ${QIPGlobalOutputDirectory}${QIPGlobalHoroscopesOutputFile}
} else {
	set i 0
	foreach flag $argv {
	  if {[string compare $flag "-NORUN"] == 0} {
	    puts $QIParseVerboseIntro
	    exit;
	  } elseif {[string compare $flag "-v"] == 0} {
            set QIPGlobalRunVerbose "YES"
	    puts $QIParseVerboseIntro
	  } elseif {[string compare $flag "-t"] == 0} {
		set QIPGlobalHTMLTemplate [lindex $argv [expr $i+1]]
	  } elseif {[string compare $flag "-h"] == 0} {
		set QIPGlobalSourceHost [lindex $argv [expr $i+1]]
	  } elseif {[string compare $flag "-f"] == 0} {
		set QIPGlobalSourceFile [lindex $argv [expr $i+1]]
	  } elseif {[string compare $flag "-x"] == 0} {
		set QIPGlobalOutputFile [lindex $argv [expr $i+1]]
	  } elseif {[string compare $flag "-RSS"] == 0} {
		set QIP_MODE "RSS"
	  } elseif {[string compare $flag "-Horoscopes"] == 0 } {
		set QIP_MODE "Horoscopes"
	  } elseif {[string first "-" $flag]} {
		# " This is a value: $flag"
	  } else {
		set QIP_MODE "Horoscopes"
	  }
	  incr i
	}
}
#####################################
## Parse and Write to Disk
#####################################
	if {[string compare $QIP_MODE "RSS"] == 0} {
		#########################
		## RSS
		#########################

		## Checking RSS defaults...
		if {[string compare $QIPGlobalHTMLTemplate "DEFAULT"] != 0} {
		    set QIPGlobalHTMLRSSTemplate $QIPGlobalHTMLTemplate 
		}
		if {[string compare $QIPGlobalOutputFile "DEFAULT"] != 0} {
		    set QIPGlobalRSSOutputFile $QIPGlobalOutputFile 
		}
		if {[string compare $QIPGlobalSource "DEFAULT"] != 0} {
		    set QIPGlobalRSSSource $QIPGlobalSource
		}
		if {[string compare $QIPGlobalSourceHost "DEFAULT"] != 0} {
		    set QIPGlobalRSSSourceHost $QIPGlobalSourceHost
		}
		if {[string compare $QIPGlobalSourceFile "DEFAULT"] != 0} {
		    set QIPGlobalRSSSourceFile $QIPGlobalSourceFile
		}
		
		set content [loadSource $QIPGlobalRSSSourceFile $QIPGlobalRSSSourceHost]
		#########################
		## Parsing RSS files...
		#########################
		if {[string compare $QIPGlobalRunVerbose "YES"] == 0} {
		    puts "Content fetched...\n"
		}
		source QIPRSSParse.tcl
		rssParse $content
		toFile [toHTML] ${QIPGlobalOutputDirectory}${QIPGlobalRSSOutputFile}
		if {[string compare $QIPGlobalRunVerbose "YES"] == 0} {
	    	   puts "Output written to ${QIPGlobalOutputDirectory}${QIPGlobalRSSOutputFile}.\n"
		}
	} else {
		#########################
		## Horoscopes
		#########################

		## Checking Horoscopes defaults...
		if {[string compare $QIPGlobalHTMLTemplate "DEFAULT"] != 0} {
		    set QIPGlobalHTMLHoroscopesTemplate $QIPGlobalHTMLTemplate 
		}
		if {[string compare $QIPGlobalOutputFile "DEFAULT"] != 0} {
		    set QIPGlobalHoroscopesOutputFile $QIPGlobalOutputFile 
		}
		if {[string compare $QIPGlobalSource "DEFAULT"] != 0} {
		    set QIPGlobalHoroscopesSource $QIPGlobalSource
		}
		if {[string compare $QIPGlobalSourceHost "DEFAULT"] != 0} {
		    set QIPGlobalHoroscopesSourceHost $QIPGlobalSourceHost
		}
		if {[string compare $QIPGlobalSourceFile "DEFAULT"] != 0} {
		    set QIPGlobalHoroscopesSourceFile $QIPGlobalSourceFile
		}

		set content [loadSource $QIPGlobalHoroscopesSourceFile $QIPGlobalHoroscopesSourceHost]

		#########################
		## Parsing Horoscopes files...
		#########################
		if {[string compare $QIPGlobalRunVerbose "YES"] == 0} {
		    puts "Content fetched...\n"
		}
		source QIPHorosParse.tcl
		horosParse $content
		toFile [toHTML] ${QIPGlobalOutputDirectory}${QIPGlobalHoroscopesOutputFile}
		if {[string compare $QIPGlobalRunVerbose "YES"] == 0} {
	    	   puts "Output written to ${QIPGlobalOutputDirectory}${QIPGlobalHoroscopesOutputFile}.\n"
	}
}

## TO DO: handle change of loadSource
## setup... ALSO ALSO ALSO change from http:.../....xml format for users
## to $host $file mechanism, which should also handle local files...

## There is a slight bug/messiness; if you name your HTML template or source
## file or export file with a leading '-' nothing will happen, it's just not
## terribly attractive, considering my slash and burn approach to parsing
## flags at the command line. 

## In my somewhat grand(ish) tradition of useless comments,
## Now Listening to: The Velvet Underground, Pale Blue Eyes.
